 
extern	struct	_iobuf {
	int	_cnt;
	unsigned char *_ptr;
	unsigned char *_base;
	int	_bufsiz;
	short	_flag;
	char	_file;		 
} _iob[];
extern struct _iobuf 	*fopen();
extern struct _iobuf 	*fdopen();
extern struct _iobuf 	*freopen();
extern struct _iobuf 	*popen();
extern struct _iobuf 	*tmpfile();
extern long	ftell();
extern char	*fgets();
extern char	*gets();
extern char	*sprintf();
extern char	*ctermid();
extern char	*cuserid();
extern char	*tempnam();
extern char	*tmpnam();
 
 
 
 
 
 
 
 
    
 
 
typedef	int jmp_buf[9 ];
 
typedef	int sigjmp_buf[9 +1];
int	setjmp( );
int	_setjmp( );
int	sigsetjmp( );
void	longjmp( );
void	_longjmp( );
void	siglongjmp( );
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
typedef int SystemSemaphore;
 
 
 
 
 
 
 
typedef union lispunion *LispObject;
 
struct hunk_structure {
  short        type;
  short        gc;
  LispObject   next_hunk;
  int          hunk_size;
};
typedef struct Object_struct
{
  short type;
  short gc;
  LispObject class;
} Object_t;
struct envobject {
  Object_t		header;
  LispObject    	variable;
  LispObject    	value;
  struct envobject *	next;
  LispObject		mutable;
};
typedef struct envobject *Env;
 
struct object_structure {
  Object_t	header;
  LispObject    slots[1];	 
};
struct integer_structure {
  Object_t 	header;
  int		value_part;
};
 
struct float_structure {
  Object_t 	header;
  double	fvalue;
};
struct bignum_structure {
Object_t header;
  int *         bnum;
};
struct complex_structure {
  Object_t header;
  LispObject	real;
  LispObject	imaginary;
};
struct ratio_structure {
  Object_t header;
  LispObject	numerator;
  LispObject	denominator;
};
struct character_structure {
  Object_t header; 
  unsigned char	font;
  unsigned char	code;
};
struct symbol_structure {
  Object_t	header;
  int 		hash;	   
  LispObject    lmodule;   
  LispObject	lvalue;    
  LispObject	gvalue;    
  LispObject	plist;
  LispObject    pname;
  LispObject left;
  LispObject right;
};
 
struct table_structure {
  Object_t header; 
  LispObject	(*comparator)(LispObject*);
  LispObject    lisp_comparator;
  LispObject	tree;
};
 
struct vector_structure {
  Object_t header;
  int length;			 
  LispObject base;   		
};
struct cons_structure {
  Object_t header;
  LispObject	car;
  LispObject	cdr;
};
struct stream_structure {
  Object_t header;
  struct _iobuf *		handle;
  LispObject	name;
  int		curchar;
  int		mode;
};
struct string_structure {
  Object_t header;
  int length;
  char value;  
};
struct funcallable_object_structure {
  Object_t header;
  LispObject    (*cfun)();
  LispObject    cfun_arg;
};
struct continue_structure {
  Object_t header;
  LispObject    value;      
  LispObject    target;     
  LispObject    thread;
  LispObject  *gc_stack_pointer;  
  Env           dynamic_env;
  LispObject    last_continue;
  LispObject    handler_stack;
  LispObject    dp;   
   
  jmp_buf       machine_state;
  int           live;
  int           unwind;
};
struct thread_structure {
  Object_t header;
  LispObject*  gc_stack_base;
  
  LispObject 	state;
  LispObject    fun;
  LispObject    args;
  LispObject    value;
  LispObject    parent;
  LispObject    cochain;
  int           status;
  int           stack_size;
  int           gc_stack_size;
  int*          stack_base;
};
struct semaphore_structure {
  Object_t header;
  SystemSemaphore semaphore;  
};
struct class_structure {
  Object_t header;
  LispObject	name;	        
  LispObject	superclasses;   
  LispObject    subclasses;     
  LispObject    slot_table;     
  LispObject    slot_list;      
  LispObject    direct_slot_list;  
  LispObject    precedence;     
  int           local_count;    
};
struct instance_structure {
  Object_t	header;
  LispObject	slots;		 
};
 
 
struct special_structure {
  Object_t header;
  LispObject    name;
  Env           env;
  LispObject	(*func)();
};
 
struct function_structure {
  Object_t	 header;
  LispObject    name;       
  LispObject    home;       
  Env		env;        
  int		argtype;    
};
struct c_function_structure {
  Object_t      header;
  LispObject  name;
  LispObject  home;
  Env         env;
  int         argtype;
  LispObject  (*func)();    
};
struct i_function_structure {
  Object_t	header;
  LispObject    name;
  LispObject    home;  
  Env		env;
  int		argtype;	
  LispObject	bvl;		 
  LispObject	body;            
};
 
struct generic_structure {   
  Object_t 	header;
  LispObject    name;
  LispObject    home;
  Env           env;            
  int           argtype;
  LispObject    method_class;
  LispObject    discriminator;
  LispObject    cache_table;
  LispObject    method_table;   
};
 
struct method_structure {
  Object_t header;
  LispObject    qualifier;      
  LispObject    signature;      
  LispObject    host;           
  LispObject    function;       
  LispObject           fixed;          
};
 
 
struct module_structure {
  Object_t      header;
  LispObject  name;               
  LispObject  home;               
  LispObject  imported_modules;   
  LispObject  exported_names;     
  LispObject  bindings;
};
struct c_module_structure {
  Object_t    header;
  LispObject  name;
  LispObject  home;
  LispObject  imported_modules;
  LispObject  exported_names;
  LispObject  bindings;
  
  LispObject  values;             
  LispObject  entry_count;
  LispObject  (**functions)();    
};
typedef struct c_module_structure MODULE;
struct i_module_structure {
  Object_t     header;
  LispObject   name;
  LispObject   home;
  LispObject   imported_modules;      
  LispObject   exported_names;        
  LispObject   bindings;
  int          bounce_flag;
};
 
 
 
 
 
 
 
 
 
 
 
 
typedef	int		sigset_t;	 
typedef	unsigned int	speed_t;	 
typedef	unsigned long	tcflag_t;	 
typedef	unsigned char	cc_t;		 
typedef	int		pid_t;		 
typedef	unsigned short	mode_t;		 
typedef	short		nlink_t;	 
typedef	long		clock_t;	 
typedef	long		time_t;		 
typedef	int		size_t;		 
typedef int		ptrdiff_t;	 
typedef	unsigned short	wchar_t;	 
 
 
 
 
 
typedef	unsigned char	u_char;
typedef	unsigned short	u_short;
typedef	unsigned int	u_int;
typedef	unsigned long	u_long;
typedef	unsigned short	ushort;		 
typedef	unsigned int	uint;		 
typedef	struct  _physadr_t { int r[1]; } *physadr_t;
typedef	struct label_t {
	int	val[2];
} label_t;
typedef	struct	_quad_t { long val[2]; } quad_t;
typedef	long	daddr_t;
typedef	char *	caddr_t;
typedef	unsigned long	ino_t;
typedef	short	dev_t;
typedef	long	off_t;
typedef	unsigned short	uid_t;
typedef	unsigned short	gid_t;
typedef	long	key_t;
typedef	char *	addr_t;
 
typedef	long	fd_mask;
typedef	struct fd_set {
	fd_mask	fds_bits[(((256 )+(( (sizeof (fd_mask) * 8		)	)-1))/( (sizeof (fd_mask) * 8		)	)) ];
} fd_set;
 
 
 
 
 
 
 
 
struct	linger {
	int	l_onoff;		 
	int	l_linger;		 
};
 
 
 
struct sockaddr {
	u_short	sa_family;		 
	char	sa_data[14];		 
};
 
struct sockproto {
	u_short	sp_family;		 
	u_short	sp_protocol;		 
};
 
 
 
struct msghdr {
	caddr_t	msg_name;		 
	int	msg_namelen;		 
	struct	iovec *msg_iov;		 
	int	msg_iovlen;		 
	caddr_t	msg_accrights;		 
	int	msg_accrightslen;
};
 
 
 
 
 
 
 
 
 
 
 
struct in_addr {
	union {
		struct { u_char s_b1,s_b2,s_b3,s_b4; } S_un_b;
		struct { u_short s_w1,s_w2; } S_un_w;
		u_long S_addr;
	} S_un;
};
 
 
 
struct sockaddr_in {
	short	sin_family;
	u_short	sin_port;
	struct	in_addr sin_addr;
	char	sin_zero[8];
};
 
 
 
extern	char	_ctype_[];
 
 
 
struct	hostent {
	char	*h_name;	 
	char	**h_aliases;	 
	int	h_addrtype;	 
	int	h_length;	 
	char	**h_addr_list;	 
};
 
struct	netent {
	char		*n_name;	 
	char		**n_aliases;	 
	int		n_addrtype;	 
	unsigned long	n_net;		 
};
struct	servent {
	char	*s_name;	 
	char	**s_aliases;	 
	int	s_port;		 
	char	*s_proto;	 
};
struct	protoent {
	char	*p_name;	 
	char	**p_aliases;	 
	int	p_proto;	 
};
struct rpcent {
	char	*r_name;	 
	char	**r_aliases;	 
	int	r_number;	 
};
struct hostent	*gethostbyname(), *gethostbyaddr(), *gethostent();
struct netent	*getnetbyname(), *getnetbyaddr(), *getnetent();
struct servent	*getservbyname(), *getservbyport(), *getservent();
struct protoent	*getprotobyname(), *getprotobynumber(), *getprotoent();
struct rpcent	*getrpcbyname(), *getrpcbynumber(), *getrpcent();
 
extern  int h_errno;	
 
 
 
 
 
 
 
 
typedef	int	faultcode_t;	 
 
 
 
 
 
 
void	(*signal())();
 
void  (*sigset())();
int   sighold();
int   sigrelse();
int   sigignore();
 
struct	sigvec {
	void	(*sv_handler)();	 
	int	sv_mask;		 
	int	sv_flags;		 
};
 
 
struct	sigstack {
	char	*ss_sp;			 
	int	ss_onstack;		 
};
 
struct	sigcontext {
	int	sc_onstack;		 
	int	sc_mask;		 
	int	sc_sp;			 
	int	sc_pc;			 
	int	sc_npc;			 
	int	sc_psr;			 
	int	sc_g1;			 
	int	sc_o0;
	int	sc_wbcnt;		 
	char	*sc_spbuf[31	];  
	int	sc_wbuf[31	][16];  
};
 
 
 
 
 
 
 
struct	sigaction {
	void 		(*sa_handler)();
	sigset_t	sa_mask;
	int		sa_flags;
};
 
void	(*signal())();
int	kill( );
int	sigaction( 
);
int	sigaddset( );
int	sigdelset( );
int	sigemptyset( );
int	sigfillset( );
int	sigismember( );
int	sigpending( );
int	sigprocmask( );
int	sigsuspend( );
extern int getdtablesize(void);
 
typedef int SocketHandle;
typedef struct sockaddr SocketName;
typedef struct sockaddr_in SocketInName;
typedef int SocketPort;
typedef struct hostent Host;
struct listener_structure {
  Object_t header;
  
  SocketHandle   socket;
  SocketInName   name;
  int            state;
};
struct socket_structure {
  Object_t 	 header;
  SocketHandle   socket;
  SocketInName   name;
  char           buffer[10240 ];  
  int            state;
};
 
struct c_object_structure {
  Object_t header;
  LispObject  *slots;         
  char        first_c_byte;  
};
 
struct weak_wrapper_structure {
  Object_t header;
  LispObject  object;
};
union lispunion {
  struct hunk_structure         HUNK;
  struct object_structure	OBJECT;
  struct integer_structure	INT;
  struct float_structure	FLOAT;
  struct bignum_structure	BIGNUM;
  struct complex_structure	COMPLEX;
  struct ratio_structure	RATIO;
  struct character_structure	CHAR;
  struct symbol_structure	SYMBOL;
  struct table_structure	TABLE;
  struct cons_structure		CONS;
  struct stream_structure	STREAM;
  struct string_structure       STRING;
  struct thread_structure       THREAD;
  struct semaphore_structure    SEMAPHORE;
  struct class_structure	CLASS;
  struct instance_structure	INSTANCE;
  struct vector_structure       VECTOR;
  struct continue_structure	CONTINUE;
  struct envobject		ENV;
  struct special_structure      SPECIAL;
  struct function_structure     FUNCTION;
  struct c_function_structure   C_FUNCTION;
  struct i_function_structure   I_FUNCTION;
 
  struct function_structure     MACRO;
  struct c_function_structure   C_MACRO;
  struct i_function_structure   I_MACRO;
 
  struct module_structure       MODULE;
  struct c_module_structure     C_MODULE;
  struct i_module_structure     I_MODULE;
  struct listener_structure     LISTENER;
  struct socket_structure       SOCKET;
  struct c_object_structure     C_OBJECT;
  struct weak_wrapper_structure WEAK_WRAPPER;
};
 
 
 
 
 
 
 
 
extern int system_running_processors;
 
 
 
 
 
 
 
 
 
extern int system_scheduler_number;
extern char *system_malloc(int);
extern char *system_static_malloc(int);
extern LispObject system_thread_rig(LispObject*,LispObject);
extern LispObject system_thread_start(LispObject);
extern LispObject system_thread_call(LispObject);
extern LispObject system_thread_suspend(void);
extern LispObject system_thread_reschedule(void);
extern void system_thread_abort(void);
 
 
 
 
 
 
 
 
extern LispObject system_scheduler_threads[(1) ] ;
 
extern void runtime_initialise_system(void);
extern void system_initialise_scheduler(void);
extern void system_lisp_exit(int);
extern            int GC_state ;
 
 
	 
      
				        
				  
      
				        
				  
 
 
 
	
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
extern LispObject ObList;
extern LispObject Object;
extern LispObject nil;
extern LispObject lisptrue;
extern LispObject unbound;
 
extern LispObject Object;
extern LispObject  Standard_Class;
extern LispObject   Slot_Description_Class;
extern LispObject     Slot_Description;
extern LispObject      Local_Slot_Description;
extern LispObject Abstract_Class;
 
extern LispObject Structure_Class;                 
extern LispObject Funcallable_Object_Class;        
extern LispObject Generic_Class;
extern LispObject Pair_Class;
extern LispObject Unpredictable_Fixed_Size_Class;  
extern LispObject Variable_Size_Keyed_Class;       
extern LispObject Thread_Class;
extern LispObject Method_Class;
 
extern LispObject Abstract_Class;  
extern LispObject Number, Complex, Real, Rational, Integer;
extern LispObject Symbol, Character, String;
extern LispObject Thread, Continue;
extern LispObject Function, Generic, Method;
 
extern LispObject Cons, Vector, Table, Null;
 
extern LispObject Weak_Wrapper;
 
extern LispObject Slot_Initarg;
extern LispObject Default_Initargs;
extern LispObject Object_Class;      
extern LispObject Class_Name;
extern LispObject Class_Parent;
extern LispObject Class_Children;
extern LispObject Class_Instance_Description;
extern LispObject Slot_Class;  
extern LispObject Slot_Name;                     
extern LispObject Slot_Position;
extern LispObject Slot_Reader;
extern LispObject Slot_Writer;
extern LispObject Slot_Initform;   
extern LispObject Slot_Value;      
extern void make_special_symbol(LispObject*, LispObject *, char * );
extern void put_table( LispObject, LispObject );
extern void bootstrap(LispObject*);
extern LispObject Fn_plus(LispObject*);
extern LispObject Fn_difference(LispObject*);
 
extern void initialise_vectors(LispObject* );
 
LispObject Fn_symbolvalue(LispObject *) ;
 
extern LispObject q_eof;
 
extern struct cons_structure *free_cons;
extern struct cons_structure *cons_hunks;
extern struct symbol_structure *free_symbol;
extern struct symbol_structure *symbol_hunks;
extern struct table_structure *free_table;
extern struct table_structure *table_hunks;
extern struct vector_structure *free_vectors;
extern struct vector_structure *vector_hunks;
extern struct function_structure *free_function;
extern struct function_structure *function_hunks;
extern struct string_structure *free_string;
extern struct string_structure *string_hunks;
extern struct character_structure *free_character;
extern struct character_structure *character_hunks;
extern struct stream_structure *free_stream;
extern struct stream_structure *stream_hunks;
extern struct integer_structure *free_integer;
extern struct integer_structure *integer_hunks;
extern struct float_structure *free_float;
extern struct float_structure *float_hunks;
extern struct ratio_structure *free_ratio;
extern struct ratio_structure *ratio_hunks;
extern struct complex_structure *free_complex;
extern struct complex_structure *complex_hunks;
extern struct condition_structure *free_condition;
extern struct condition_structure *condition_hunks;
extern struct continue_structure *free_continue;
extern struct continue_structure *continue_hunks;
extern struct module_structure *free_module;
extern struct module_structure *module_hunks;
extern struct class_structure *free_class;
extern struct class_structure *class_hunks;
extern struct instance_structure *free_instance;
extern struct instance_structure *instance_hunks;
extern struct thread_structure *free_thread;
extern struct thread_structure *thread_hunks;
extern LispObject free_methods;
extern LispObject method_hunks;
extern Env free_env;
extern Env env_hunks;
int add_root(LispObject *);
LispObject  Fn_cons(LispObject *) ;
extern LispObject allocate_symbol(LispObject*,char *);
extern LispObject allocate_table(LispObject*,LispObject (*)(LispObject*));
LispObject allocate_vector(LispObject *,int);
LispObject allocate_static_vector(LispObject *,int);
extern LispObject allocate_function(int,LispObject(*)(), int, LispObject);
extern LispObject Fn_eq(LispObject*);
extern LispObject Fn_equal(LispObject*);
extern LispObject Fn_read(LispObject*);
extern LispObject Fn_prin(LispObject*);
extern LispObject Fn_print(LispObject*);
extern LispObject Fn_nreverse(LispObject*);
extern LispObject Fn_make_table(LispObject*);
extern LispObject Fn_tref(LispObject*);
extern LispObject tref_updator(LispObject*);
extern LispObject table_copy(LispObject*);
extern LispObject Fn_length(LispObject*);
extern LispObject allocate_char(LispObject*,char);
extern LispObject allocate_stream(LispObject*,struct _iobuf *, int);
extern LispObject allocate_string(LispObject*,char *,int);
extern LispObject static_ints;
extern LispObject real_allocate_integer(LispObject*, int);
    
extern LispObject allocate_ratio(LispObject*,LispObject, LispObject);
extern LispObject allocate_float(LispObject*,double);
extern LispObject allocate_complex(LispObject*,LispObject, LispObject);
extern LispObject allocate_continue(LispObject*);
extern LispObject allocate_thread(LispObject*,int, int, int);
extern LispObject allocate_module(LispObject*,LispObject, Env, LispObject);
extern LispObject make_module_function(LispObject*,
				       char *, LispObject(*)(), int);
extern LispObject make_special(char *, LispObject(*)());
extern LispObject allocate_env(LispObject*,LispObject, LispObject, LispObject);
extern LispObject allocate_envimut(LispObject*,
				   LispObject, LispObject, LispObject);
extern LispObject allocate_condition_class(LispObject*,int, LispObject, 
					   LispObject, LispObject);
extern LispObject allocate_class(LispObject*,LispObject);
extern LispObject allocate_instance(LispObject*,LispObject);
extern LispObject Fn_set(LispObject*);
extern void set_associate(LispObject*,LispObject, LispObject);
extern void set_anon_associate(LispObject*,LispObject, LispObject);
extern void initialise_input(LispObject*);
extern void re_initialise_input(void);
extern LispObject sym_quote;
extern LispObject sym_quasiquote;
extern LispObject sym_unquote;
extern LispObject sym_progn;
extern LispObject sym_defun;
extern LispObject sym_defglobal;
extern LispObject sym_setq;
extern void initialise_output(LispObject*);
extern void initialise_eval(void);
extern LispObject sym_lambda;
extern void initialise_basic(LispObject*);
extern void initialise_generics(LispObject*);
extern void initialise_chars(LispObject*);
extern void initialise_streams(LispObject*);
extern void initialise_tables(LispObject*);
extern void initialise_set(LispObject*);
extern void initialise_error(LispObject*);
extern void initialise_arith(LispObject*);
extern void initialise_threads(LispObject*);
extern void initialise_modules(LispObject*);
extern void initialise_classes(LispObject*);
extern LispObject sym_handler, sym_accept, sym_decline;
extern LispObject sym_dynamic;
extern LispObject sym_dynamic_let;
extern LispObject sym_table_copy;
extern LispObject StdIn;
extern LispObject StdOut;
extern LispObject StdErr;
extern void exit(int);
 
 
 
 
 
 
 
extern int* state_stack_base ;
extern LispObject* state_gc_stack_base ;
extern LispObject state_current_thread ;
 
extern LispObject* state_gc_stack_pointer ;
extern Env state_dynamic_env ;
extern LispObject state_last_continue ;
extern LispObject state_handler_stack ;
extern int set_continue_1(LispObject *,LispObject);
extern int set_continue_2(LispObject);
extern void call_continue(LispObject *,LispObject,LispObject);
extern LispObject *load_thread(LispObject);
			     
 
 
 
extern LispObject generic_apply(LispObject*,LispObject);
extern LispObject generic_apply_1(LispObject*, LispObject,LispObject);
extern LispObject generic_apply_2(LispObject*, LispObject,
				               LispObject, LispObject);
extern LispObject generic_apply_3(LispObject*, LispObject,
				  LispObject,LispObject,LispObject);
extern LispObject generic_apply_4(LispObject*,  LispObject,
			  LispObject, LispObject, LispObject, LispObject);
 
extern void process_import_spec(LispObject*,LispObject,LispObject);
extern LispObject symbol_ref(LispObject*,LispObject,LispObject,LispObject);
LispObject module_eval(LispObject *) ;
LispObject process_top_level_form(LispObject *) ;
LispObject old_module_eval(LispObject *) ;
LispObject module_mv_apply_1(LispObject *) ;
extern LispObject module_set(LispObject*);
extern LispObject module_set_new(LispObject*,LispObject,LispObject,LispObject);
extern LispObject module_set_new_constant(LispObject*,
					  LispObject,LispObject,LispObject);
extern LispObject put_module(LispObject*,LispObject,LispObject);
extern LispObject get_module(LispObject*,LispObject);
extern int module_loaded_p(LispObject*,LispObject);
extern int module_binding_exists_p(LispObject*,LispObject,LispObject);
extern LispObject register_module_import(LispObject*);
extern LispObject process_exports(LispObject*);
extern LispObject global_module_table;
extern            LispObject current_interactive_module ;
 
 
 
 
LispObject apply_nary_bytefunction(LispObject * , int args, LispObject fn);
void add_boot_module(LispObject);
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
extern int pagesize;
 
 
 
extern LispObject allocate_module_function(LispObject*,LispObject,LispObject,
				    LispObject (*)(LispObject*),int);
extern LispObject allocate_i_module(LispObject*,LispObject);
extern LispObject allocate_i_function(LispObject*,LispObject,LispObject,int);
extern LispObject allocate_buffered_continue(void);
extern LispObject allocate_special(LispObject*,LispObject,LispObject (*)());
extern LispObject allocate_generic(LispObject,int);
extern LispObject allocate_semaphore(LispObject*);
extern LispObject allocate_thread(LispObject*,int,int, int);
extern LispObject allocate_n_conses(LispObject *, int);
extern LispObject allocate_listener(LispObject*);
extern LispObject allocate_socket(LispObject*);
extern LispObject allocate_c_object(LispObject*, int,int);
extern SystemSemaphore table_sem,symbol_sem,cons_sem,vector_sem,string_sem,
  char_sem,stream_sem,integer_sem,condition_sem,continue_sem,module_sem,
  class_sem,instance_sem,thread_sem;
extern SystemSemaphore env_sem;
 
extern void runtime_initialise_allocator(LispObject*);
extern void runtime_reset_allocator(LispObject *);
extern char *allocate_page(LispObject*,int);
extern void deallocate_page(LispObject*,char *,int);
extern char *allocate_space(LispObject*,int);
extern void deallocate_space(LispObject*,char *,int);
extern void promote_free_space(LispObject*);
extern char *allocate_stack(LispObject*,int);
extern void free_stack(LispObject*,char *,int);
extern void allocate_static_integers(LispObject*);
extern void open_module(LispObject *,MODULE *,LispObject *,char *,int);
extern void close_module(void);
extern LispObject make_module_function(LispObject *,char *,
				       LispObject (*)(LispObject*),int);
extern LispObject make_unexported_module_function(LispObject *,
						  char *, LispObject (*)(LispObject *),
						  int);
extern LispObject make_unexported_module_special(
		       LispObject *,char *,LispObject (*)(LispObject *));
extern LispObject make_module_special(LispObject *,
				      char *,LispObject (*)(LispObject *));
extern LispObject make_module_entry(LispObject *,char *,LispObject);
extern LispObject make_module_entry_using_symbol(LispObject *,LispObject,LispObject);
extern LispObject make_module_generic(LispObject *,char *,int);
extern LispObject make_wrapped_module_generic(
		     LispObject *, char *,int,LispObject (*)(LispObject *));
extern LispObject make_module_method_1(LispObject *,
		      LispObject,LispObject (*)(LispObject *),LispObject);
extern LispObject make_module_method_2(LispObject *,
				       LispObject,LispObject (*)(LispObject *),
				       LispObject,LispObject);
extern LispObject make_unexported_function(LispObject *, char *,
					   LispObject (*)(LispObject *),int);
extern 
  LispObject 
    make_anonymous_module_env_function_2(LispObject *,LispObject,
					 LispObject (*)(LispObject *),
					 int,LispObject,LispObject,
					 LispObject,LispObject);
extern 
  LispObject 
    make_anonymous_module_env_function_1(LispObject *,LispObject,
					 LispObject (*)(LispObject *),
					 int,LispObject,LispObject);
 
extern LispObject make_nary(char *,LispObject (*)(LispObject *),int);
extern LispObject make_module_macro(LispObject *,char *,LispObject (*)(LispObject *),int);
   
 
	  
	   
	   
	  
	   
	  
	   
	   
	   
	   
	  
	   
 	
 
 
 
 
 
typedef unsigned char bytecode;
static LispObject ByteFunction_Class;
static LispObject ByteFunction;
static LispObject boot_modules[50];
static int boot_module_count=1;
static bytecode exit_bytes[] = { 	28  };
static int static_count; static LispObject *statics[256]; static LispObject static_vectors[256];  static bytecode *bytevectors[256];  static int exec_counts[256];
static LispObject Cb_fn_return;
LispObject compute_and_apply_method();
LispObject call_method();
LispObject module_apply_args();
LispObject interpret_bytes(LispObject *stacktop, bytecode *start_pc, int context)
{
  
  LispObject BCtrue=lisptrue;
  LispObject BCnil=nil;
  LispObject BC_globals;
  bytecode *pc;
  LispObject *sp;
  int this_vector;
  
 BCnil=nil; 
 BCtrue=lisptrue; 
 ; 
 sp=stacktop-1;  
 pc=start_pc; 
 this_vector=context;;
  while ((1) )
    {
       
 exec_counts[*pc]++;;
      switch(*(pc++))
	{
	  
	  
 case 0 : 
 break;
	  
	  
	  
 case 1 : 
 { 
 int i,j; 
 LispObject tmp; 
 
 i= (int)(*(pc++)); 
 i=(i<<8)+((int)(*(pc++))); 
 i=(i<<8)+((int)(*(pc++))); 
 i= *(pc++) ? -i: i; 
 ;; 
 j= (int)(*(pc++)); 
 j=(j<<8)+((int)(*(pc++))); 
 j=(j<<8)+((int)(*(pc++))); 
 j= *(pc++) ? -j: j; 
 ;; 
 (*(++sp)=statics[i][j]); 
 } break;
	  
 case 2 : 
 { 
 int i,j; 
 
 i= (int)(*(pc++)); 
 i=(i<<8)+((int)(*(pc++))); 
 i=(i<<8)+((int)(*(pc++))); 
 i= *(pc++) ? -i: i; 
 ;; 
 j= (int)(*(pc++)); 
 j=(j<<8)+((int)(*(pc++))); 
 j=(j<<8)+((int)(*(pc++))); 
 j= *(pc++) ? -j: j; 
 ;; 
 statics[i][j] = (*(sp--)); 
 } break;
	  
 case  4 : 
 { 
 int j; 
 LispObject tmp; 
 j= (int)(*(pc++)); 
 j=(j<<8)+((int)(*(pc++))); 
 j=(j<<8)+((int)(*(pc++))); 
 j= *(pc++) ? -j: j; 
 ;; 
 (*(++sp)=statics[this_vector][j]); 
 } break;
	  
 case 5 : 
 { 
 int i; 
 LispObject tmp; 
 i= (int)(*(pc++)); 
 i=(i<<8)+((int)(*(pc++))); 
 i=(i<<8)+((int)(*(pc++))); 
 i= *(pc++) ? -i: i; 
 ;; 
 tmp=((i>=0 && i<1024 ) ? (*(&((static_ints)->VECTOR.base) + (i)))  : real_allocate_integer(sp+1,i)) ; 
 (*(++sp)=tmp); 
 } break;
	  
 case  6 : 
 { 
 int j; 
  
 j= (int)(*(pc++)); 
 j=(j<<8)+((int)(*(pc++))); 
 j=(j<<8)+((int)(*(pc++))); 
 j= *(pc++) ? -j: j; 
 ;; 
 statics[this_vector][j]=(*(sp--)); 
 } break;
	  
 case 3 : 
 { 
 switch (*(pc++)) 
 { 
 case 0: 
 (*(++sp)=BCnil); 
 break; 
 
 case 1: 
 (*(++sp)=BCtrue); 
 break; 
 
 default: 
 fprintf((&_iob[2]) ,"odd special"); 
 (*(++sp)=BCnil); 
 break; 
 } 
 } break;
	  
	  
 case 7 : 
 { 
 int i; 
 LispObject tmp; 
 
 i = *(pc++);; 
  
 tmp=(*((sp)-(i))); 
 (*(++sp)=tmp); 
 } break;
	  
 case 8 : 
 { 
 int i; 
 
 
 i = *(pc++);; 
 
 (*((sp)-(i)))=(*(sp)); 
 ((sp) -= (1)); 
 } break;
	  
	  
	  
 case 9 : 
 { 
 int depth,keep,n,counter; 
 
 
 depth = *(pc++);; 
 
 keep = *(pc++);; 
 sp-= depth; n=depth-keep; for (counter=0; counter<keep; counter++) { sp++; *sp=*(sp+n); } } break;
	  
 case        10 : 
 { 
 LispObject tmp; 
 
 tmp=*sp; 
 *sp = *(sp-1); 
 *(sp-1) = tmp; 
 } break;
	  
 case 	11 : 
 { 
 int i; 
 
 
 i = *(pc++); 
 ((sp) -= (i)); 
 } break;
	  
	  
	  
 case 	12 : 
 { 
 int i,j,counter; 
 LispObject env=(*(sp)); 
 
 
 i = *(pc++);; 
 
 j = *(pc++);; 
 counter=i; while (counter) { env=(*(&((env)->VECTOR.base) + (0))) ; counter--; } env=(*(&((env)->VECTOR.base) + (j+1))) ;; 
 ((*(sp))=env); 
 } break;
	  
 case 	13 : 
 { 
 int i,j,counter; 
 LispObject env; 
 LispObject val; 
 val=(*(sp--)); 
 env=(*(sp)); 
 
 
 i = *(pc++);; 
 
 j = *(pc++);; 
 counter=i; while (counter) { env=(*(&((env)->VECTOR.base) + (0))) ; counter--; } (*(&((env)->VECTOR.base) + (j+1))) =val;; 
 } break;
	  
 case 	14 : 
 { 
 int i,counter; 
 LispObject env=(*(sp)); 
 
 
 i = *(pc++);; 
 counter=i; while (counter) { env=(*(&((env)->VECTOR.base) + (0))) ; counter--; }; 
 ((*(sp))=env); 
 } break;
	  
 case 	15 : 
 { 
 int i; 
 
 
 i = *(pc++);; 
 
 { 
 LispObject tmp; 
  
 tmp=allocate_vector(sp+1, i+1); 
 (*(&((tmp)->VECTOR.base) + (0))) = (*(sp)); 
 ((*(sp))=tmp); 
 }; 
 { if (1) { BCnil=nil; BCtrue=lisptrue; } }; 
 } break;
	  
	  
 case 	16 : 
 { 
 LispObject tmp=(*(sp--)); 
  
 ((*(sp))=(*(&(((*(sp)))->VECTOR.base) + ( 
 ((tmp)->INT.value_part) ))) ); 
 } break;
	  
 case 	17 : 
 { 
 LispObject val=(*(sp--)); 
 LispObject loc; 
 loc=(*(sp--)); 
  
 (*(&(((*(sp)))->VECTOR.base) + (((loc)->INT.value_part) ))) =val; 
 ((*(sp))=val); 
 } break;
	  
 case 	18 : 
 { 
 LispObject obj=(*(sp)); 
 int i; 
  
 
 i = *(pc++);; 
 ((*(sp))= (*(&((obj)->INSTANCE.slots) + (i))) ); 
 } break;
	  
 case 	19 : 
 { 
 LispObject val; 
 LispObject obj; 
 int i; 
  
 val=(*(sp--)); 
 obj=(*(sp)); 
  
 
 i = *(pc++);; 
  (*(&((obj)->INSTANCE.slots) + (i))) =val; 
 ((*(sp))=val); 
 } break;
	  
 case 	20 : 
 { 
 LispObject type; 
 type=(*(sp--)); 
  
   (((*(sp)))->OBJECT.header.type) =((type)->INT.value_part) ; 
 } break;
	  
	  
	  
 case 	21 : 
 { 
 int i; 
 bytecode *opc=pc; 
 
 i= (int)(*(pc++)); 
 i=(i<<8)+((int)(*(pc++))); 
 i=(i<<8)+((int)(*(pc++))); 
 i= *(pc++) ? -i: i; 
 ;; 
 pc=
 ((opc)+((i)-1)); 
 } break;
	  
 case 	22 : 
 { 
 int i; 
 
 if ((*(sp--))==BCnil) 
 { 
 bytecode *opc=pc; 
 i= (int)(*(pc++)); 
 i=(i<<8)+((int)(*(pc++))); 
 i=(i<<8)+((int)(*(pc++))); 
 i= *(pc++) ? -i: i; 
 ;; 
 pc=
 ((opc)+((i)-1)); 
 } 
 else 
 pc+=sizeof(int); 
 } break;
	  
	  
 case 		23 : 
 { 
 int nargs,abs_args,real_args; 
 LispObject fn; 
 LispObject *arg_start; 
  
 nargs=(int)((char) *(pc++));; 
 abs_args=nargs<0? -nargs: nargs; 
 fn=(*(sp--)); 
  
 switch( 	((fn)->OBJECT.header.type) ) 
 { 
 case    (0x63 | 0x100) : 
 { 
 LispObject ptr,*walker; 
 LispObject meths; 
 LispObject *arg_1; 
 int count; 
 
 arg_1=sp-nargs; 
 arg_1++; 
  
 ptr=     (((	( (*(&(((fn))->INSTANCE.slots) + (3))) ) )->CONS).car) ; 
  
 if (ptr!=nil) 
 { 
  
 walker=arg_1; 
 count=0; 
 while (count<nargs &&      (((ptr)->CONS).car) ==     ((*(walker))->OBJECT.header.class) ) 
 { 
 ptr=     (((ptr)->CONS).cdr) ; 
 walker++; 
 count++; 
 } 
 
 if (count==nargs) 
 { 
 meths=     (((	( (*(&(((fn))->INSTANCE.slots) + (3))) ) )->CONS).cdr) ; 
 goto call_method; 
 } 
 
  
 
 ptr=	( (*(&(((fn))->INSTANCE.slots) + (4))) ) ; 
 walker=arg_1; 
 count=0; 
 
 while(ptr!=nil && count<nargs) 
 { 
 if (     (((     (((ptr)->CONS).car) )->CONS).car) ==     ((*(walker))->OBJECT.header.class) ) 
 {  
 ptr=     (((     (((ptr)->CONS).car) )->CONS).cdr) ; 
 walker++; 
 count++; 
 } 
 else 
 ptr=     (((ptr)->CONS).cdr) ; 
 } 
 
 if (count==nargs) 
 { 
 	( (*(&(((fn))->INSTANCE.slots) + (3))) ) =ptr; 
 meths=     (((ptr)->CONS).cdr) ; 
 goto call_method; 
 } 
  
 } 
  
 
  
  
 { 
 LispObject res,args; 
 LispObject *stacktop=sp+1,*stackbase=arg_1; 
 (*stacktop = (fn) , stacktop++) ; 
 args=allocate_n_conses(stacktop,nargs); 
 ptr=args; 
 
 walker=stackbase; 
 count=0; 
 while (count<nargs) 
 { 
      (((ptr)->CONS).car) = *walker; 
 ptr=     (((ptr)->CONS).cdr) ; 
 ++walker; 
 ++count; 
 } 
 (fn) = *--stacktop ; 
 
 res=( (*stacktop)  = fn, (*(stacktop+1))  =  args, compute_and_apply_method (stacktop) )			        ; 
 { if (1) { BCnil=nil; BCtrue=lisptrue; } }; 
 (sp)=(arg_1-1);; 
 pc=
 ((this_vector=((int)(*(sp)))>>(18+2)), 
 (*(sp))=((LispObject) (((int)((*(sp))))&((1<<(18+2)) - 1))), 
 (bytevectors[this_vector])+((((int)(*(sp)))>>2)) 
 ); 
 ((sp) -= (1)); 
 ((*(sp))=res); 
 break;  
 } 
 
 call_method: 
  
 
 { 
 LispObject mf; 
 
 mf=	 (*(&((     (((meths)->CONS).car) )->INSTANCE.slots) + (3)))  ; 
 switch( 	((mf)->OBJECT.header.type) ) 
 { 
 case (0x7a | 0x100) : 
  
 (*((arg_1)-(2))=meths); 
 { 
  
  
 pc=(this_vector=(( (*(&((mf)->INSTANCE.slots) + (2)))  )->INT.value_part) , 
 (bytevectors[(( (*(&((mf)->INSTANCE.slots) + (2)))  )->INT.value_part) ]) 
 +(( (*(&((mf)->INSTANCE.slots) + (1)))  )->INT.value_part) ); 
  
 (*(++sp)=	 (*(&((mf)->INSTANCE.slots) + (0)))  ); 
 }; 
 break; 
 
 default: 
 { 
 LispObject res; 
 res = call_method(arg_1,nargs,meths); 
 { if (1) { BCnil=nil; BCtrue=lisptrue; } }; 
 (sp)=(arg_1-1);; 
 pc=
 ((this_vector=((int)(*(sp)))>>(18+2)), 
 (*(sp))=((LispObject) (((int)((*(sp))))&((1<<(18+2)) - 1))), 
 (bytevectors[this_vector])+((((int)(*(sp)))>>2)) 
 ); 
 ((sp) -= (1)); 
 ((*(sp))=res); 
 break; 
 } 
 } 
 }; 
 } 
 break; 
 
 case (0x7a | 0x100) : 
 case (0x7b | 0x200) : 
 { 
 int real_args=((	 (*(&((fn)->INSTANCE.slots) + (3)))  )->INT.value_part) ; 
 if (nargs>=0 && real_args<0) 
 { 
 int j=nargs+1; 
 int k=-real_args; 
 *(++sp)=BCnil; 
  
 while (k!=j) 
 { 
 LispObject tmp; 
 sp--; 
 tmp=Fn_cons(sp); 
 *sp=tmp; j--; 
 } 
 { if (1) { BCnil=nil; BCtrue=lisptrue; } }; 
 } 
 { 
  
  
 pc=(this_vector=(( (*(&((fn)->INSTANCE.slots) + (2)))  )->INT.value_part) , 
 (bytevectors[(( (*(&((fn)->INSTANCE.slots) + (2)))  )->INT.value_part) ]) 
 +(( (*(&((fn)->INSTANCE.slots) + (1)))  )->INT.value_part) ); 
  
 (*(++sp)=	 (*(&((fn)->INSTANCE.slots) + (0)))  ); 
 }; 
 } 
 break; 
 default: 
 { 
 LispObject res; 
 arg_start=sp-abs_args; 
 res=module_apply_args(arg_start+1,nargs,fn); 
 { if (1) { BCnil=nil; BCtrue=lisptrue; } }; 
 ((sp) -= (abs_args)); 
 pc=
 ((this_vector=((int)(*(sp)))>>(18+2)), 
 (*(sp))=((LispObject) (((int)((*(sp))))&((1<<(18+2)) - 1))), 
 (bytevectors[this_vector])+((((int)(*(sp)))>>2)) 
 ); 
 ((sp) -= (1)); 
 ((*(sp))=res); 
 } 
 break; 
 } 
 } break;
	  
 case 		24 : 
 { 
 LispObject fn; 
 int nargs; 
 
 nargs = *(pc++);; 
  
 fn=(*(sp--)); 
 { 
  
  
 pc=(this_vector=(( (*(&((fn)->INSTANCE.slots) + (2)))  )->INT.value_part) , 
 (bytevectors[(( (*(&((fn)->INSTANCE.slots) + (2)))  )->INT.value_part) ]) 
 +(( (*(&((fn)->INSTANCE.slots) + (1)))  )->INT.value_part) ); 
  
 (*(++sp)=	 (*(&((fn)->INSTANCE.slots) + (0)))  ); 
 }; 
 } break;
	  
 case 	25 : 
 { 
 LispObject ml; 
 int args; 
 LispObject *base; 
 
 
 args = *(pc++);; 
 base=sp-args; 
 
 ml=(*(sp--)); 
 
 
 { 
 LispObject mf; 
 
 mf=	 (*(&((     (((ml)->CONS).car) )->INSTANCE.slots) + (3)))  ; 
 switch( 	((mf)->OBJECT.header.type) ) 
 { 
 case (0x7a | 0x100) : 
  
 (*((base)-(2))=ml); 
 { 
  
  
 pc=(this_vector=(( (*(&((mf)->INSTANCE.slots) + (2)))  )->INT.value_part) , 
 (bytevectors[(( (*(&((mf)->INSTANCE.slots) + (2)))  )->INT.value_part) ]) 
 +(( (*(&((mf)->INSTANCE.slots) + (1)))  )->INT.value_part) ); 
  
 (*(++sp)=	 (*(&((mf)->INSTANCE.slots) + (0)))  ); 
 }; 
 break; 
 
 default: 
 { 
 LispObject res; 
 res = call_method(base,args,ml); 
 { if (1) { BCnil=nil; BCtrue=lisptrue; } }; 
 (sp)=(base-1);; 
 pc=
 ((this_vector=((int)(*(sp)))>>(18+2)), 
 (*(sp))=((LispObject) (((int)((*(sp))))&((1<<(18+2)) - 1))), 
 (bytevectors[this_vector])+((((int)(*(sp)))>>2)) 
 ); 
 ((sp) -= (1)); 
 ((*(sp))=res); 
 break; 
 } 
 } 
 }; 
 } break;
	  
 case 	26 : 
 {  
 bytecode *new_pc; 
 LispObject xx; 
 int i; 
 bytecode *opc=pc; 
  
 i= (int)(*(pc++)); 
 i=(i<<8)+((int)(*(pc++))); 
 i=(i<<8)+((int)(*(pc++))); 
 i= *(pc++) ? -i: i; 
 ;; 
 new_pc=
 ((opc)+((i)-1)); 
 ; 
 xx=
 ((LispObject) 
 ((this_vector<<(18+2)) 
 | (((new_pc)-(bytevectors[this_vector])) << 2) 
 | 3)); 
 (*(++sp)=xx); 
 } break;
	  
	  
	  
 case 	27 :  
 { 
 LispObject tmp=(*(sp--)); 
  
 pc=
 ((this_vector=((int)(*(sp)))>>(18+2)), 
 (*(sp))=((LispObject) (((int)((*(sp))))&((1<<(18+2)) - 1))), 
 (bytevectors[this_vector])+((((int)(*(sp)))>>2)) 
 ); 
 ((sp) -= (1)); 
 ((*(sp))=tmp); 
 } break;
	  
	  
 case 	28 : 
 { 
 ; 
 return ((*(sp--))); 
 } break;
	  	
	  
 case 	29 : 
 { 
 LispObject tmp; 
  
 tmp=Fn_cons(sp-1); 
 ((sp) -= (1)); 
 ((*(sp))=tmp); 
 { if (1) { BCnil=nil; BCtrue=lisptrue; } }; 
 } break;
	  
 case 30 : 
 {  
 LispObject env; 
 LispObject rpc; 
 LispObject tmp,tmp2; 
 bytecode *start; 
 int vector; 
 int nargs; 
  
 nargs=(int)((char) *(pc++));; 
 
 tmp=allocate_instance(sp+1,ByteFunction); 
   ((tmp)->OBJECT.header.type) =(0x7a | 0x100) ; 
 	 (*(&((tmp)->INSTANCE.slots) + (0)))  =(*(sp--)); 
 
  
 rpc=(*(sp--)); 
 start=
 ((vector=((int)rpc)>>(18+2)), 
 rpc=((LispObject) (((int)(rpc))&((1<<(18+2)) - 1))), 
 (bytevectors[vector])+((((int)rpc)>>2)) 
 ); 
 (*(++sp)=tmp); 
 tmp2=((vector>=0 && vector<1024 ) ? (*(&((static_ints)->VECTOR.base) + (vector)))  : real_allocate_integer(sp+1,vector)) ; 
 tmp=(*(sp)); 
  (*(&((tmp)->INSTANCE.slots) + (2)))  =tmp2; 
 tmp=((nargs>=0 && nargs<1024 ) ? (*(&((static_ints)->VECTOR.base) + (nargs)))  : real_allocate_integer(sp+1,nargs)) ; 
 	 (*(&(((*(sp)))->INSTANCE.slots) + (3)))  =tmp; 
 tmp=((start-(bytevectors[vector])>=0 && start-(bytevectors[vector])<1024 ) ? (*(&((static_ints)->VECTOR.base) + (start-(bytevectors[vector]))))  : real_allocate_integer(sp+1,start-(bytevectors[vector]))) ; 
  (*(&(((*(sp)))->INSTANCE.slots) + (1)))  =tmp; 
 { if (1) { BCnil=nil; BCtrue=lisptrue; } }; 
 } break;
	  
	  
 case 32 : 
 { 
 if ((*(sp))==BCnil)
 ((*(sp))=BCtrue); 
 else 
 ((*(sp))=BCnil); 
 } break;
	  
 case 	33 : 
 { 
 LispObject tmp; 
  
 tmp=(*(sp--)); 
  
 if ((*(sp))==tmp) 
 ((*(sp))=BCtrue); 
 else 
 ((*(sp))=BCnil); 
 } break;
	  
	  
 case 35 : 
 { 
 LispObject tmp; 
 tmp=((this_vector>=0 && this_vector<1024 ) ? (*(&((static_ints)->VECTOR.base) + (this_vector)))  : real_allocate_integer(sp+1,this_vector)) ; 
 (*(++sp)=tmp); 
 } 
 break; 
	  
	  
 default: 
 fprintf((&_iob[2]) ,"No such instruction: %d\n",*(pc-1));;
	}
    }
  
  return nil; 
}
LispObject Fn_add_codevector (LispObject *stackbase) { LispObject bytes; LispObject len; LispObject  posn; LispObject *stacktop = stackbase+3; bytes = (*stackbase) ; len = (*(stackbase+1)) ;  posn = (*(stackbase+2)) ; 
{
  LispObject new_closure;
  LispObject ptr;
  int i,lim=((len)->INT.value_part) ;
  bytecode *space;
  space=(bytecode *)allocate_space(stacktop,lim);
  ptr=bytes;
  for (i=0; i<lim ; i++)
    {
      if (!   ( 	((     (((ptr)->CONS).car) )->OBJECT.header.type)  == (0x11) ) )
	CallError(stacktop,"add codevector: bad byte",     (((ptr)->CONS).car) ,(3) );
      
      if (((     (((ptr)->CONS).car) )->INT.value_part) >255)
	CallError(stacktop,"add codevector: bad byte number",     (((ptr)->CONS).car) ,(3) );
      space[i]=(bytecode)((     (((ptr)->CONS).car) )->INT.value_part) ;
      ptr=     (((ptr)->CONS).cdr) ;
    }
  new_closure=allocate_instance(stacktop,ByteFunction);
    ((new_closure)->OBJECT.header.type) =(0x7a | 0x100) ;
   (*(&((new_closure)->INSTANCE.slots) + (1)))  =((0>=0 && 0<1024 ) ? (*(&((static_ints)->VECTOR.base) + (0)))  : real_allocate_integer(stacktop,0)) ;
  	 (*(&((new_closure)->INSTANCE.slots) + (3)))  =((0>=0 && 0<1024 ) ? (*(&((static_ints)->VECTOR.base) + (0)))  : real_allocate_integer(stacktop,0)) ;
  	 (*(&((new_closure)->INSTANCE.slots) + (0)))  =nil;
   (*(&((new_closure)->INSTANCE.slots) + (2)))  =posn;
  bytevectors[((posn)->INT.value_part) ]=space;
  return new_closure;
}
 } 
LispObject Fn_load_bytecodes (LispObject *stackbase) { LispObject name; LispObject *stacktop = stackbase+1; name = (*stackbase) ; 
{
  char buf[1024];
  struct _iobuf  *file;
  bytecode *code;
  int nslots,nbytes,i;
  LispObject slotvector,*slots;
  
  sprintf(buf,"%s.ebc",(&((name)->STRING.value)) );
  file=fopen(buf,"r");
  if (file==0 )
    CallError(stacktop,"Could not open file\n",name,(3) );
  fgets(buf,1024,file);
  
  if (strcmp(buf,"ASCIIBYTES\n",buf)==0)
    {
      fgets(buf,1024,file);
      nslots=atoi(buf);
      fgets(buf,1024,file);
      nbytes=atoi(buf);
      code=(bytecode *) allocate_space(stacktop,nbytes);      
      bytevectors[static_count]=code;
      slotvector=allocate_static_vector(stacktop,sizeof(LispObject)*nslots);
      static_vectors[static_count]=slotvector;
      slots=&((*(&((slotvector)->VECTOR.base) + (0))) );
      fprintf((&_iob[2]) ,"code: %x[%d] slots: %x[%d]\n",code,nbytes,slots,nslots);
      statics[static_count]=slots;
      
      for (i=0 ; i<nbytes ; i++)
	{	
	  if (fgets(buf,1024,file)==0 )
	    perror("fgets");
	  code[i]=(bytecode) (atoi(buf));
	}
      fclose(file);
    }
  else
    {	
      fprintf((&_iob[2]) ,"%s\n",buf);
      CallError(stacktop,"Unknown format: %s\n",nil,(3) );
    }
  
  
  
  sprintf(buf,"%s.est",(&((name)->STRING.value)) );
  file=fopen(buf,"r");
  if (file==0 )
    CallError(stacktop,"load-bytecodes: no file",nil,(3) );
  else
    {
      extern LispObject Fn_Lex_Yacc_reader(LispObject*,struct _iobuf  *);
      LispObject new;
      new=Fn_Lex_Yacc_reader(stacktop,file);
      nslots=((new)->INT.value_part) ;
      for (i=0; i<nslots ; i++)
	{
	  new=Fn_Lex_Yacc_reader(stacktop,file);
	  statics[static_count][i]=new;
	}
    }
  
  {
    LispObject apply_nary_bytefunction(LispObject *, int, LispObject);
    LispObject new_closure;
    new_closure=allocate_instance(stacktop,ByteFunction);
      ((new_closure)->OBJECT.header.type) =(0x7a | 0x100) ;
     (*(&((new_closure)->INSTANCE.slots) + (1)))  =((0>=0 && 0<1024 ) ? (*(&((static_ints)->VECTOR.base) + (0)))  : real_allocate_integer(stacktop,0)) ;
    	 (*(&((new_closure)->INSTANCE.slots) + (3)))  =((0>=0 && 0<1024 ) ? (*(&((static_ints)->VECTOR.base) + (0)))  : real_allocate_integer(stacktop,0)) ;
    	 (*(&((new_closure)->INSTANCE.slots) + (0)))  =nil;
     (*(&((new_closure)->INSTANCE.slots) + (2)))  =((static_count>=0 && static_count<1024 ) ? (*(&((static_ints)->VECTOR.base) + (static_count)))  : real_allocate_integer(stacktop,static_count)) ;
    static_count++;
    
    return(apply_nary_bytefunction(stacktop,0,new_closure));
  }
}
 } 
LispObject Fn_set_module_statics (LispObject *stackbase) { LispObject module; LispObject n; LispObject *stacktop = stackbase+2; module = (*stackbase) ; n = (*(stackbase+1)) ; 
{
  int i;
  
  i=((n)->INT.value_part) ;
  module->C_MODULE.values=static_vectors[i];
  return nil;
}
 } 
LispObject apply_nary_bytefunction(LispObject *stackbase, int nargs, LispObject fn)
{
  bytecode *start;
  int this_vector; 
  LispObject rfn;
  int i;
  
  if (     ( 	((fn)->OBJECT.header.type)  == 0x1 ) )
    rfn=	 (*(&((     (((fn)->CONS).car) )->INSTANCE.slots) + (3)))  ;
  else 
    rfn=fn;
  
  
  for (i=nargs-1; i>=0 ; i--)
    *(stackbase+i+2)=*(stackbase+i);
  	
  this_vector=0;
  start=exit_bytes;
  *(stackbase+1)=
 ((LispObject) 
 ((this_vector<<(18+2)) 
 | (((start)-(bytevectors[this_vector])) << 2) 
 | 3));
  
  start=(this_vector=(( (*(&((rfn)->INSTANCE.slots) + (2)))  )->INT.value_part) , 
 (bytevectors[(( (*(&((rfn)->INSTANCE.slots) + (2)))  )->INT.value_part) ]) 
 +(( (*(&((rfn)->INSTANCE.slots) + (1)))  )->INT.value_part) );  
  
  *stackbase=fn;
  *(stackbase+nargs+2)=	 (*(&((rfn)->INSTANCE.slots) + (0)))  ;
  return(interpret_bytes(stackbase+nargs+3,start,this_vector));
}
LispObject Fn_print_counts(LispObject *stackbase) { LispObject *stacktop = stackbase; 
{
  { 
 int i,j; 
 for (i=0, j=0; i<256; i++) 
 { 
 if (exec_counts[i]!=0) 
 { 
 fprintf((&_iob[2]) ,"%3d: %7d ",i,exec_counts[i]); 
 j++; 
 if ( (j%6) == 0) 
 fputc('\n',(&_iob[2]) ); 
 } 
 } 
 if (j%6!=0) fputc('\n',(&_iob[2]) ); 
 };
  return nil;
}
 } 
void add_boot_module(LispObject mod)
{
  boot_modules[boot_module_count]=mod;
  
  static_vectors[static_count]=mod->C_MODULE.values;
  statics[static_count]=&((*(&((mod->C_MODULE.values)->VECTOR.base) + (0))) );
  boot_module_count++;
  static_count=boot_module_count;
}
LispObject Fn_boot_module_list(LispObject *stackbase) { LispObject *stacktop = stackbase; 
{
  LispObject lst,end;
  int i;
  
  lst=( (*stacktop)  = nil, (*(stacktop+1))  = nil, Fn_cons (stacktop) )			        ;
  end=lst; 
  for (i=1; i<boot_module_count; i++)
    { 
      LispObject tmp;
      tmp=( (*stacktop)  = boot_modules[i], (*(stacktop+1))  = nil, Fn_cons (stacktop) )			        ;
           (((end)->CONS).cdr) =tmp;
      end=tmp;
    }
  return(lst);
}
 } 
MODULE Module_bci;
LispObject Module_bci_values[7];
void initialise_bci(LispObject *stacktop)
{
  int i;
  
  fprintf((&_iob[2]) ,"Bytecodes compiled on: %s\n", "Wed Apr 29 17:54:52 BST 1992");
  
  
  Cb_fn_return=nil;
  add_root(&Cb_fn_return);
  ByteFunction_Class = (LispObject) allocate_class(stacktop,Standard_Class);  
  add_root(&ByteFunction_Class);
  make_class(stacktop,ByteFunction_Class,
	     "bytefunction-class",
	     Standard_Class,
	     Funcallable_Object_Class,
	     0);
  ByteFunction = (LispObject) allocate_class(stacktop,ByteFunction_Class);
  add_root(&ByteFunction);
  make_class(stacktop,ByteFunction,
	     "bytefunction",
	     ByteFunction_Class,
	     Function,  4 );
  open_module(stacktop,
	      &Module_bci,Module_bci_values,"bci",7);
  
  (void) make_module_entry(stacktop,"bytefunction-class",ByteFunction_Class);
  (void) make_module_entry(stacktop,"bytefunction",ByteFunction);
  (void) make_module_function(stacktop,"add-code-vector",Fn_add_codevector,3);
  (void) make_module_function(stacktop,"load-bytecodes",Fn_load_bytecodes,1);
  (void) make_module_function(stacktop,"set-module-statics",Fn_set_module_statics,2);
  (void) make_module_function(stacktop,"boot-module-list",Fn_boot_module_list,0);
  (void) make_module_function(stacktop,"byte-counts",Fn_print_counts,0);
  close_module();
  bytevectors[0]=exit_bytes;
}
